/*--------------------- LIBRARIES -----------------*/
// include libraries
#include <TFT.h>  
#include <SPI.h>
#include <Encoder.h>
/*--------------------- PIN DEFINITIONS -----------------*/
// configuracion pines TFT
#define TFTled 6  //con un pwm obtenemos los 3.3V
//SCK -> 13
//SDA -> 11
#define dc   9 //tambien se puede llamar A0
#define rst  8
#define cs   10 
//GND
#define TFTpwr 12 //nos permitira apargar la pantalla y mantener el controlador funcionando

// inicializacion libreria
TFT TFTscreen = TFT(cs, dc, rst);

// configuracion pines encoder
Encoder myEnc(3, 2); //CLK -> 3 y DT -> 2
#define Btn 4
#define ENCpwr 7
#define ENCgnd 5 //esto nos permite tener todos los pines correspondientes a la pantalla juntos

// pines para sensores flexion y fuerza
#define sens0 A0 //sensor 0 (flex)
#define sens1 A0 //sensor 1 (flex)
#define sens2 A0 //sensor 2 (flex)
#define sens3 A1 //sensor 3 (forz)
#define sens4 A1 //sensor 4 (forz)
#define sens5 A1 //sensor 5 (forz)

// pines para electrovalvulas
#define evalv11 A2
#define evalv12 A3

/*--------------------- GLOBAL VARIABLES -----------------*/
  #define nmodule 1 //numero de modulos instalados (apendices)
  //encoder
  long oldPosition  = -999;
  int brillo = (255*3)/5; //brillo variable por pwm (3.3v max)
  //sensores flexion
  int sx_val[3] = {0}; //valor del sensor flexion
  int sx_min[3] = {630}; //valor minimo sensor flexion (630 por defecto)
  int sx_max[3] = {300}; //valor maximo sensor flexion (300 por defecto)
   //sensores fuerza
  int sz_val[3] = {0}; //valor del sensor flexion
  int sz_min[3] = {0}; //valor minimo sensor flexion
  int sz_max[3] = {0}; //valor maximo sensor flexion

void setup() {
  Serial.begin(9600);

  setup_sensores();
  setup_encoder();
  setup_evalve(); 
  setup_tft();
}


void loop() {
  
  tft_menu();  

}
