void setup_tft()
{
  pinMode(TFTled, OUTPUT);
  pinMode(TFTpwr, OUTPUT);
  
  TFTscreen.begin();  //initialize the library
  //TFTscreen.width();
  //TFTscreen.height();
    
  TFTscreen.background(0, 0, 0);  // clear the screen with a black background
  TFTscreen.setTextSize(1);  //set the text size

  digitalWrite(TFTpwr,HIGH);
  analogWrite(TFTled,brillo); //brillo variable por pwm (3.3v max)
  
  /* Ejemplo funciones:
   * TFTscreen.line(0, 10, TFTscreen.width(), 10)  // draw a line across the screen
   * TFTscreen.noStroke(); // don&apos;t draw a line around the next rectangle
   * TFTscreen.fill(0,255,0); // set the fill color to green
   * TFTscreen.rect(0,20,TFTscreen.width(),10); //draw a rectangle across the screen
   */
}

void tft_menu()
{
  static int selec = 0;
  static int antselec = 0;
    
  //titulo menu
  TFTscreen.setTextSize(1);
  TFTscreen.stroke(255,255,255); 
  TFTscreen.text("Gripper Controler", 35, 5);
  TFTscreen.stroke(255,0,255);
  TFTscreen.line(1,18,TFTscreen.width()-1,18);
  
  //opciones menu
  TFTscreen.stroke(255,255,255);
  TFTscreen.text("> Switch to AUTO", 6, 22);
  TFTscreen.text("> Flex Sensor settings", 6, 34);
  TFTscreen.text("> Force Sensor settings", 6, 46);
  TFTscreen.text("> Manual Movements", 6, 58);
  TFTscreen.text("> ", 6, 70);
  TFTscreen.text("> ", 6, 82);
  TFTscreen.text("> Screen settings", 6, 94);
  TFTscreen.text("> Hibernate ", 6, 106);
  TFTscreen.text("> Screen Saver", 6, 118); 


  selec = read_Enco(); 
  if(selec < 0 && selec >= -9)selec=9+selec;
  if(selec < -9)selec=-selec+(selec%9)*2;
  if(selec > 8)selec=selec%9; 
  

  if(selec != antselec){
    TFTscreen.stroke(0,0,0);
    TFTscreen.rect(1,20+antselec*12,TFTscreen.width()-1,12);
    antselec = selec;
  }
  TFTscreen.stroke(0,255,0);
  TFTscreen.rect(1,20+selec*12,TFTscreen.width()-1,12);

  if(btn_fl()==1)
  {
    switch(selec)
    {
      case 0:
          mode_auto();
          break;
      case 1:
          sensor_flex();
          break;
      case 2:
          sensor_force();
          break;
      case 3:
          manual_mov();
          break;
      case 4:
      
      case 5:
          break;
      case 6:
          settings();
          break;
      case 7:
          scrsleep();
          break;
      case 8: 
          scrsaver();
          break;
    }
  }
}
