void mode_auto(){
  TFTscreen.background(0, 0, 0);
  delay(500); //evita rebotes señal del boton 
  bool back = false;
  char t_text[10];
  int zero = read_Enco(); //valor del encoder al entrar en la funcion convertido a cero
  int objetivo = 0; 
  int ant_obj = 0;
  int finger = 0;
  int diag = 0; // diagnostico
  unsigned long int tiempo = 0;

  
  
  while(back == false){  
    //titulo menu
    TFTscreen.setTextSize(1);    
    TFTscreen.stroke(255,255,255);
    TFTscreen.text("AUTOMATIC MODE", 30, 5);
                   
    TFTscreen.stroke(255,0,255);//color morado
    TFTscreen.line(1,18,TFTscreen.width()-1,18);//linea separación
  
    //cuerpo del menu
    TFTscreen.stroke(255,255,255);
    TFTscreen.text(" ", 6, 22);
    TFTscreen.text("0%  Close percentage 100%", 6, 34);
    
    TFTscreen.stroke(255,255,255); 
    TFTscreen.rect(1,44,TFTscreen.width()-1,24);
    
    
    TFTscreen.text("> Objetive: ", 6, 82);
    if(objetivo != ant_obj)
    {
      TFTscreen.stroke(0,0,0); //borrar
      itoa(ant_obj, t_text, 10);
      TFTscreen.text(t_text, 75, 82);
      TFTscreen.stroke(255,255,255);//escribir
      itoa(objetivo, t_text, 10);
      TFTscreen.text(t_text, 75, 82);
    }
    
    TFTscreen.text("> State: ", 6, 94);
    TFTscreen.stroke(0,0,255);
    TFTscreen.text("STOP", 60, 94);
    TFTscreen.stroke(255,255,255);
    
    TFTscreen.text("> Diagnosis:", 6, 106);
    TFTscreen.text("*Hold to manual mode*", 6, 118);
 
    ant_obj = objetivo;
    objetivo = read_Enco() - zero; 
    if(objetivo < 0)
      {
        zero = read_Enco();
        objetivo = read_Enco() - zero;
      }
    if(objetivo >100)
      {
        zero = read_Enco()- 100;
        objetivo = read_Enco() - zero;
      }
    
    if(objetivo != ant_obj)
      { // borra la barra anterior si cambia el valor
        TFTscreen.noStroke();
        TFTscreen.fill(0,0,0);
        TFTscreen.rect(3,46,TFTscreen.width()-5,20);
      }
    //dibuja la nueva barra
    TFTscreen.noStroke();
    TFTscreen.fill(0,155,0);
    TFTscreen.rect(3,46,objetivo*(TFTscreen.width()-5)/100,20);
    TFTscreen.noFill();

    if(digitalRead(Btn)==0)
    {
      tiempo = millis();
      while(digitalRead(Btn)==0)
      { //en bucle mientras se mantenga pulsado el boton      
        if( millis()-tiempo > 3000)
        { //si se superan 3 segundos sale al menu principal
          back=true;
          break;
        }
        if(btn_fl()==1) //llamada a la función por flanco
        {
          TFTscreen.stroke(0,0,0); // cambia estado a en progreso
          TFTscreen.text("STOP", 60, 94);
          TFTscreen.stroke(0,255,0);
          TFTscreen.text("PROGRESS", 60, 94);        
          delay(100);
          
          diag=auto_close(finger,objetivo);
          
          TFTscreen.stroke(0,0,0);//borra estado de en progreso
          TFTscreen.text("PROGRESS", 60, 94);
          
          TFTscreen.noStroke(); //elimina el ultimo mensaje de diagnostico
          TFTscreen.fill(0,0,0);
          TFTscreen.rect(77,106,TFTscreen.width()-80,12);
          TFTscreen.noFill();
          
          if(diag<0)TFTscreen.stroke(0,0,255);// errores (rojo)
          if(diag==0)TFTscreen.stroke(0,255,255);// alarmas (amarillo)
          if(diag>0)TFTscreen.stroke(0,255,0);// mensajes (verde)
          switch(diag)
          {
            case -3: //error limite tiempo
              TFTscreen.text("limit time", 78, 106);
              break;
            case -2: //error limite inferior
              TFTscreen.text("inf cap", 78, 106);
              break;
            case -1: //error limite superior
              TFTscreen.text("sup cap", 78, 106);
              break;
            case 0: //error desconocido
              TFTscreen.text("unknow", 78, 106);
              break;
            case 1: //ejecucion exitosa
              TFTscreen.text("completed", 78, 106);
              break;           
          }
          TFTscreen.stroke(255,255,255);
          break;
        }
        
      }
    }

  


  }  
  
  //esta parte limpia pantalla y evita el rebote
  TFTscreen.background(0, 0, 0);  
  while(btn_fl())
  { delay(100); }
  while(btn_fl()==0)
  { delay(100); }
}



//--------------------------------------------------

void sensor_force(){
  TFTscreen.background(0, 0, 0);
  delay(500); //evita rebotes señal del boton
  bool back = false;
  int selec = 0;
  int antselec = 0;
  int sensor = 0;
  char t_sens[10]; // entrada analogica es 2^10
  char t_min[10];
  char t_max[10];

  while(back == false){  
    //titulo menu
    TFTscreen.setTextSize(1);
    
    TFTscreen.stroke(255,255,255);
    switch(sensor){
      case 0:
        TFTscreen.text("Force Sensor 1 settings", 15, 5);
        break;
      case 1:
        TFTscreen.text("Force Sensor 2 settings", 15, 5);
        break;
      case 2:
        TFTscreen.text("Fforce Sensor 3 settings", 15, 5);
        break;
      default:
        sensor = 0; 
    }  
        
    //borra valores de los sensores
    TFTscreen.stroke(0, 0, 0); //borra el valor actual
    TFTscreen.text(t_sens, 100, 22);
  
    
    TFTscreen.stroke(255,0,255);
    TFTscreen.line(1,18,TFTscreen.width()-1,18);
  
    //opciones menu
    TFTscreen.stroke(255,255,255);
    TFTscreen.text("> Sensor Value:", 6, 22);
    TFTscreen.text("> Set as min -> ", 6, 34);
    TFTscreen.text("> Set as max ->", 6, 46);
    TFTscreen.text("> ", 6, 58);
    TFTscreen.text("> ", 6, 70);
    TFTscreen.text("> ", 6, 82);
    TFTscreen.text("> ", 6, 94);
    TFTscreen.text("> Next sensor ", 6, 106);
    TFTscreen.text("> Back", 6, 118);
 

    selec = read_Enco(); 
    if(selec < 0 && selec >= -9)selec=9+selec;
    if(selec < -9)selec=-selec+(selec%9)*2;
    if(selec > 8)selec=selec%9; 
        
    if(selec != antselec){
      TFTscreen.stroke(0,0,0);
      TFTscreen.rect(1,20+antselec*12,TFTscreen.width()-1,12);
      antselec = selec;
    }
    TFTscreen.stroke(0,255,0);
    TFTscreen.rect(1,20+selec*12,TFTscreen.width()-1,12);
  
    if(btn_fl()==1)
    {
      switch(selec)
      {
        case 0: //valor del sensor
          break;
        case 1: //set as min
                TFTscreen.stroke(0, 0, 0);
                itoa(sz_min[sensor], t_min, 10);//borra valor minimo
                TFTscreen.text(t_min, 100, 34);
                sz_min[sensor]= sz_val[0]; //toma nuevo valor
          break;  
        case 2: //set as max
                TFTscreen.stroke(0, 0, 0);
                itoa(sz_max[sensor], t_max, 10);//borra valor maximo
                TFTscreen.text(t_max, 100, 46); 
                sz_max[sensor]= sz_val[0]; //toma nuevo valor
          break;
        case 3:
          break;
        case 4:
          break;
        case 5:
          break;
        case 6:
          break;
        case 7:
          TFTscreen.background(0, 0, 0);
          sensor++;
          if(sensor>=nmodule ) sensor=0;
          break;
        case 8: 
          back = true;
          break;
      }
    }
    //imprime valores de los sensores
    
    read_sens();//adquirimos el nuevo valor
    itoa(sz_val[sensor], t_sens, 10); 
    TFTscreen.stroke(255,255,255); // imprime valor actual
    TFTscreen.text(t_sens, 100, 22);

    TFTscreen.stroke(255,255,255); //imprime valor min
    itoa(sz_min[sensor], t_min, 10);
    TFTscreen.text(t_min, 100, 34);
    
    TFTscreen.stroke(255,255,255); //imprime valor max
    itoa(sz_max[sensor], t_max, 10);
    TFTscreen.text(t_max, 100, 46);

  }  
  TFTscreen.background(0, 0, 0);
}

//--------------------------------------------------
void sensor_flex(){
  TFTscreen.background(0, 0, 0);
  delay(500); //evita rebotes señal del boton
  bool back = false;
  int selec = 0;
  int antselec = 0;
  int sensor = 0;
  char t_sens[10]; // entrada analogica es 2^10
  char t_min[10];
  char t_max[10];

  while(back == false){  
    //titulo menu
    TFTscreen.setTextSize(1);
    
    TFTscreen.stroke(255,255,255);
    switch(sensor){
      case 0:
        TFTscreen.text("Flex Sensor 1 settings", 15, 5);
        break;
      case 1:
        TFTscreen.text("Flex Sensor 2 settings", 15, 5);
        break;
      case 2:
        TFTscreen.text("Flex Sensor 3 settings", 15, 5);
        break;
      default:
        sensor = 0; 
    }  
        
    //borra valores de los sensores
    TFTscreen.stroke(0, 0, 0); //borra el valor actual
    TFTscreen.text(t_sens, 102, 22);
  
    
    TFTscreen.stroke(255,0,255);
    TFTscreen.line(1,18,TFTscreen.width()-1,18);
  
    //opciones menu
    TFTscreen.stroke(255,255,255);
    TFTscreen.text("> Sensor Value:", 6, 22);
    TFTscreen.text("> Set as Open -> ", 6, 34);
    TFTscreen.text("> Set as Close->", 6, 46);
    TFTscreen.text("> ", 6, 58);
    TFTscreen.text("> ", 6, 70);
    TFTscreen.text("> ", 6, 82);
    TFTscreen.text("> ", 6, 94);
    TFTscreen.text("> Next sensor ", 6, 106);
    TFTscreen.text("> Back", 6, 118);
 

    selec = read_Enco(); 
    if(selec < 0 && selec >= -9)selec=9+selec;
    if(selec < -9)selec=-selec+(selec%9)*2;
    if(selec > 8)selec=selec%9; 
        
    if(selec != antselec){
      TFTscreen.stroke(0,0,0);
      TFTscreen.rect(1,20+antselec*12,TFTscreen.width()-1,12);
      antselec = selec;
    }
    TFTscreen.stroke(0,255,0);
    TFTscreen.rect(1,20+selec*12,TFTscreen.width()-1,12);
  
    if(btn_fl()==1)
    {
      switch(selec)
      {
        case 0: //valor del sensor
          break;
        case 1: //set as min
                TFTscreen.stroke(0, 0, 0);
                itoa(sx_min[sensor], t_min, 10);//borra valor minimo
                TFTscreen.text(t_min, 102, 34);
                sx_min[sensor]= sx_val[0]; //toma nuevo valor
          break;  
        case 2: //set as max
                TFTscreen.stroke(0, 0, 0);
                itoa(sx_max[sensor], t_max, 10);//borra valor maximo
                TFTscreen.text(t_max, 102, 46); 
                sx_max[sensor]= sx_val[0]; //toma nuevo valor
          break;
        case 3:
          break;
        case 4:
          break;
        case 5:
          break;
        case 6:
          break;
        case 7:
          TFTscreen.background(0, 0, 0);
          sensor++;
          if(sensor>=nmodule) sensor=0;
          break;
        case 8: 
          back = true;
          break;
      }
    }
    //imprime valores de los sensores
    
    read_sens();//adquirimos el nuevo valor
    itoa(sx_val[sensor], t_sens, 10); 
    TFTscreen.stroke(255,255,255); // imprime valor actual
    TFTscreen.text(t_sens, 102, 22);

    TFTscreen.stroke(255,255,255); //imprime valor min
    itoa(sx_min[sensor], t_min, 10);
    TFTscreen.text(t_min, 102, 34);
    
    TFTscreen.stroke(255,255,255); //imprime valor max
    itoa(sx_max[sensor], t_max, 10);
    TFTscreen.text(t_max, 102, 46);

  }  
  TFTscreen.background(0, 0, 0);
}



//--------------------------------------------------



void manual_mov(){
  TFTscreen.background(0, 0, 0);
  delay(500); //evita rebotes señal del boton
  bool back = false;
  int selec = 0;
  int antselec = 0;
  int finger = 0;


  while(back == false){  
    //titulo menu
    TFTscreen.setTextSize(1);
    
    TFTscreen.stroke(255,255,255);
    switch(finger){
      case 0:
        TFTscreen.text("Finger 1 movement", 15, 5);
        break;
      case 1:
        TFTscreen.text("Finger 2 movement", 15, 5);
        break;
      case 2:
        TFTscreen.text("Finger 3 movement", 15, 5);
        break;
      default:
        finger = 0; 
    }  
            
    TFTscreen.stroke(255,0,255);
    TFTscreen.line(1,18,TFTscreen.width()-1,18);
  
    //opciones menu
    TFTscreen.stroke(255,255,255);
    TFTscreen.text("> Close", 6, 22);
    TFTscreen.text("> Open", 6, 34);
    TFTscreen.text("> Lock", 6, 46);
    TFTscreen.text("> ", 6, 58);
    TFTscreen.text("> ", 6, 70);
    TFTscreen.text("> ", 6, 82);
    TFTscreen.text("> ", 6, 94);
    TFTscreen.text("> Next finger ", 6, 106);
    TFTscreen.text("> Back", 6, 118);
 

    selec = read_Enco(); 
    if(selec < 0 && selec >= -9)selec=9+selec;
    if(selec < -9)selec=-selec+(selec%9)*2;
    if(selec > 8)selec=selec%9; 
        
    if(selec != antselec){
      TFTscreen.stroke(0,0,0);
      TFTscreen.rect(1,20+antselec*12,TFTscreen.width()-1,12);
      antselec = selec;
    }
    TFTscreen.stroke(0,255,0);
    TFTscreen.rect(1,20+selec*12,TFTscreen.width()-1,12);
  
    if(btn_fl()==1)
    {
      switch(selec)
      {
        case 0: //cerrar
          do{ //una segunda pulsacion para el cierre
          man_close();
          TFTscreen.stroke(0,0,255);
          TFTscreen.text("o", 60, 22);
          }while(btn_fl()==0);
          
          TFTscreen.stroke(0,0,0);
          TFTscreen.text("o", 60, 22);
          TFTscreen.stroke(255,255,255);
          man_lock(); //bloquea 
         
          break;
        case 1: //abrir
          do{ //una segunda pulsacion para la apertura
          man_open();
          TFTscreen.stroke(0,0,255);
          TFTscreen.text("o", 60, 34);
          }while(btn_fl()==0);
          
          TFTscreen.stroke(0,0,0);
          TFTscreen.text("o", 60, 34);
          TFTscreen.stroke(255,255,255);
          man_lock(); //bloquea    
          break;  
        case 2: //bloquear estado
          man_lock();
          break;
        case 3:
          break;
        case 4:
          break;
        case 5:
          break;
        case 6:
          break;
        case 7:
          TFTscreen.background(0, 0, 0);
          finger++;
          if(finger>nmodule-1) finger=0;
          break;
        case 8: 
          back = true;
          break;
      }
    }

  }  
  TFTscreen.background(0, 0, 0);
}



//--------------------------------------------------
